import Ajv from 'ajv';
import localize from 'ajv-i18n';
import ajvErrors from 'ajv-errors';
import { formatColor, formatPartialTime } from './utils';
import { JSONSchema7 } from 'json-schema';

let ajvInstance: Ajv.Ajv;
function getAjv() {
    if (!ajvInstance) {
        ajvInstance = new Ajv({allErrors: true, jsonPointers: true });
        ajvInstance.addFormat('color', formatColor);
        ajvInstance.addFormat('partial-time', formatPartialTime);
        ajvErrors(ajvInstance);
    }
    return ajvInstance;
}
export function ajvComplie(schema: JSONSchema7) {
    return getAjv().compile(schema);
}
export function validForm() {
    console.log('进行了验证');

    const validate = ajvComplie(this.schema);
    const valid = validate(this.value);
    localize.zh(validate.errors);

    if (!valid) {
      this.validError = true;
      this.validErrorMessage = {};
      for (const item of validate.errors) {
        this.formatedErrorMessage(item);
      }
    } else {
      this.validError = false;
      this.validErrorMessage = {};
    }

    console.log('valid error message:', validate.errors, this.validErrorMessage);

  }
